<?
// $Id: parser.php 5140 2012-04-11 15:02:10Z calicant $

// numero massimo di inclusioni
define ("MAX_INC_LIMIT", 100);
// numero massimo di sostituzioni ricorsive
define ("MAX_SUBST_LIMIT", 100);

class parser
{
    var $debug = 0;
    // destinazione del debug (stdout | file)
    var $debug_to = 'stdout';
    var $debug_fp = false;

    var $connh;
    var $publisher;
    var $content;
    var $risoluzione = '';
    var $fileout = '';
    var $PRISCILLA_SESSION;
    var $bodytoparse = array();

    var $inclimit = 0;
    var $scaninc = false;
    var $sys_scaninc = false;

    var $vtable;

    function parser($connh, &$content, $vtable, &$PRISCILLA_SESSION, $publisher='')
    {
        $this->connh = $connh;
        $this->content =& $content;
        $this->PRISCILLA_SESSION =& $PRISCILLA_SESSION;
        $this->vtable = $vtable;
        $this->error = false;

        if ($this->debug && $this->debug_to == 'file')
            $this->set_debug_fp();

        if ($publisher != '')
            $this->publisher = $publisher;
    }

    function set_debug_fp()
    {
        $this->debug_fp = fopen("debug.txt", "w");
        register_shutdown_function(array($this, "debug_clean"));
    }

    function set_dump($ris)
    {
        $this->risoluzione = $ris;
    }

    function set_resource($resource)
    {
        clearstatcache();
        // se la risorsa da parsare e' un file
        if (is_file($resource))
        {
            if ($this->debug)
                $this->out_debug($resource." is a file");

            if (!file_exists($resource))
                return false;

            $this->bodytoparse = file($resource);
        }
        else // altrimenti se e' una variabile
        {
            $pathinfo = pathinfo($resource);
            if ($pathinfo['dirname'] != '' && $pathinfo['basename'] != '' && $pathinfo['extension'] != '')
                $this->bodytoparse[] = '';
            else
            {
                if ($this->debug)
                    $this->out_debug($resource." is a var");

                $this->bodytoparse = explode("\n", $resource);
                foreach ($this->bodytoparse as $k=>$v)
                    $this->bodytoparse[$k] = $v."\n";
            }
        }

        return true;
    }

    function scanner($file)
    {
        // se abbiamo raggiunto il limite massimo di inclusioni
        if ($this->inclimit > MAX_INC_LIMIT)
            die ("<br /><br />INCREMENTO MASSIMO DI INCLUSIONI RAGGIUNTO");

        // se sto includendo, controllo il nome del file (include/nome o nome)
        if ($this->scaninc)
        {
            if (!strstr($file, 'include/'))
                $file = PRISCILLA_LOCAL_PATH.'include/'.$file;
            else 
                $file = PRISCILLA_LOCAL_PATH.$file;

            if (dirname($file) != PRISCILLA_LOCAL_PATH.'include')
                return false;

            if (!$this->set_resource($file)) {
                echo "$file xe false!";
                return false;
            }
        }
        else $this->set_resource($file);

        // per ogni riga del bodytoparse
        foreach ($this->bodytoparse as $buffer) {
            if ($this->debug)
                $this->out_debug("--------------------------<br />\n<b>RIGA</b>:".htmlspecialchars($buffer));

            // spezza la riga in 3 parti ($row)
            // 1: pretag
            // 2: tag
            // 3: posttag
            $row = $this->find_tag($buffer);

            if ($row) {
                if ($this->debug)
                    $this->out_debug("Tagfind = true");

                preg_match("/<%(\W*\w*)(\s*.*)%>/", $buffer, $match);

                // se ci sono tag tra graffe annidati nel tag loop li parsiamo
                if (preg_match("/\{(.*)\}/i", $match[2])) {
                    if ($this->debug)
                        $this->out_debug("trovato tag tra graffe dentro la dichiarazione del tag loop");

                    $this->parse_string($match[2], $this->content);
                }

                $tagstring = $match[1];

                //(\s*\w*\s*)\s*=\"?(\s*.*\s*)
                preg_match_all("/\s*(\w+)\s*=\s*\"(.+)\"\s*/iU", $match[2], $regs);

                if ($this->debug)
                    $this->out_debug("Reg exp: tagstring:".$tagstring);

                foreach ($regs[1] as $key=>$val)
                    $tagparam[$val] = $regs[2][$key];

                if ($this->debug) {
                    $this->out_debug("Reg exp: param");
                    $this->out_debug($tagparam);
                }
                //$tagparam[tagname] = $tagstring;

                // non ammettiamo 2 tag nella riga
                //if (find_tag($row[3])) die ("<BR><BR>err_find_tag");

                if ($inblk)
                {
                    if ($this->debug) 
                        $this->out_debug("inblk = true");

                    // trovato un <%end%> dentro un blocco
                    if (preg_match("/^end$/i", $tagstring))
                    {
                        if ($this->debug) 
                            $this->out_debug("tag <%end%>");

                        $blocco .= $row[1];

                        if ($this->debug) 
                            $this->out_debug("blocco $blocco");

                        // processo la stringa $blocco che ho accumulato tra begin e end

                        // chiamiamo la funzione utente
                        if ($this->debug) 
                            $this->out_debug("chiama funzione ".$this->vtable['loop'][$func_call]);


                        $modulename = $this->vtable['modules'][$func_call];

                        if ($modulename != '') {
                            if (file_exists(PRISCILLA_PLUGINS_PATH.$modulename."/inc/".$modulename."_loop.inc.php"))
                                require_once $modulename."/inc/".$modulename."_loop.inc.php";
                            elseif (file_exists(PRISCILLA_LOCAL_PATH."modules/".$modulename."/inc/".$modulename."_loop.inc.php"))
                                require_once PRISCILLA_LOCAL_PATH."modules/".$modulename."/inc/".$modulename."_loop.inc.php";
                        }

                        if (function_exists($this->vtable['loop'][$func_call])) {
                            // call_user_func($this->vtable['loop'][$func_call], $this->connh, $this->content, $this->risoluzione, $this->PRISCILLA_SESSION, $tagparam, $this->publisher, $blocco);

                            $cfparam = array(
                                &$this->connh,
                                &$this->content,
                                $this->risoluzione,
                                &$this->PRISCILLA_SESSION,
                                $tagparam,
                                &$this->publisher,
                                $blocco
                            );

                            $ret = call_user_func_array($this->vtable['loop'][$func_call], $cfparam);
                        }

                        $blocco = '';
                        $tagparam = array();
                        $inblk = false;

                        $this->publisher->publish($row[3], $this->risoluzione);
                    }
                    else
                    {
                        // trovato un <%tag> non <%end> dentro un blocco
                        // lanciare la ricorsione con i pericoli conseguenti? o ignorare?
                        echo "<br /><br />err_annidati";
                    }
                }
                // trovato un <%tag> fuori da un blocco
                else // !$inblk
                {
                    if ($this->debug) 
                        $this->out_debug("inblk = false");

                    if ($tagstring == "include")
                    {
                        //preg_match("/file\s*=\s*(.+)$/i", $tagstring, $match);
                        // trovato un tag di inclusione
                        $this->publisher->publish($row[1], $this->risoluzione);
                        $this->inclimit ++;
                        $this->scaninc = true;
                        if ($tagparam['system'] == 'true') $this->sys_scaninc = true;
                        else $this->sys_scaninc = false;
                        $this->scanner($tagparam['file']);
                        $this->publisher->publish($row[3], $this->risoluzione);
                        $tagparam = array();
                    }
                    else
                    {
                        if ($this->debug) 
                            $this->out_debug("tag found");

                        // trovato un <%tag> generico
                        $this->publisher->publish($row[1], $this->risoluzione);
                        $func_call = $tagstring;
                        $inblk = true;
                    }
                    $blocco .= $row[3];
                }
            }
            else { // !$row
                if ($this->debug) 
                    $this->out_debug("tagfind = false");

                // riga non contenente <%tag>
                if ($inblk) {
                    if ($this->debug) 
                        $this->out_debug("tag graffe tra loop");

                    $blocco .= $buffer;

                    if ($this->debug) 
                        $this->out_debug("blocco: $blocco");
                }
                else { // !$inblk
                    if ($this->debug) 
                        $this->out_debug("tag graffe senza loop");

                    if (trim($buffer) != '')
                        $this->publisher->publish($buffer, $this->risoluzione);
                }
            }
        }

        if ($inblk)
        {
            // file terminato con blocco non chiuso
            die("<br /><br />Unclosed tag found");
        }

        $this->bodytoparse = array();
    }

    function find_tag($buffer)
    {
        $p1 = strpos($buffer, '<%');
        $p2 = strpos($buffer, '%>');
        if ($p1 > -1 && $p2 > -1 && $p1 < $p2)
        {
            $len = strlen($buffer);
            $regs[1] = substr($buffer, 0, $p1);
            $regs[2] = trim(substr($buffer, $p1+2, $p2-$p1-2));
            $regs[3] = substr($buffer, -$len+$p2+2);
            return $regs;
        }
        else return false;
    }

    // parsa i tag lineari
    function parse_string(&$string, &$row)
    {
        if ($this->debug) 
            $this->out_debug("<hr /><b>begin parse_string di </b>".htmlspecialchars($string));

        $breakWhile = false;
        $match = array();

        while (($count++ < MAX_SUBST_LIMIT) && preg_match("/\{(\w*)(\s*\w*\s*=\s*\"?[^\{\}]+\"?\s*)*\}/i", $string, $match))
        {
            
            //$string = html_entity_decode($string);

            //foreach ($match as $key=>$val) $match[$key] = html_entity_decode($val);
            //foreach ($match as $key=>$val) $match[$key] = $val;
            if ($this->debug)
                $this->out_debug("<b>parse_string di</b> $string");

            $tagstring = $match[1];

            if ($this->debug) {
                $this->out_debug("<b>tagstring</b> $tagstring");
                $this->out_debug("Reg exp di tag graffe - match");
                $this->out_debug($match);
            }
            // per ogni tag trovato nel blocco
            $tagparam[$tagstring] = array();
            $options = array();
            $o = preg_match_all("/\s*(\w+)\s*=\s*\\\*\"(.*)\\\*\"\s*/iU", $match[2], $options);

            foreach ($options[1] as $key=>$val)
                $tagparam[$tagstring][$val] = $options[2][$key];

            if ($this->debug)
            {
                $this->out_debug("options di $tagstring");
                $this->out_debug($tagparam[$tagstring]);
            }

            // se non si vuole il parsing annidato
            if ($tagparam[$tagstring]['nest'] == 'false')
            {
                if ($this->debug) 
                    $this->out_debug("nest option deactivated<br />".$match[0]);

                $breakWhile = true;
            }

            // se trova la funzione corrispondente nei tag_linear
            $modulename = $this->vtable['modules'][$tagstring];

            if ($modulename != '') {
                if (file_exists(PRISCILLA_PLUGINS_PATH.$modulename."/inc/".$modulename."_linear.inc.php"))
                    require_once $modulename."/inc/".$modulename."_linear.inc.php";
                elseif (file_exists(PRISCILLA_LOCAL_PATH."modules/".$modulename."/inc/".$modulename."_linear.inc.php"))
                    require_once PRISCILLA_LOCAL_PATH."modules/".$modulename."/inc/".$modulename."_linear.inc.php";
            }

            if (function_exists($this->vtable['linear'][$tagstring])) {
                if ($this->debug) 
                    $this->out_debug("call linear function ".$this->vtable['linear'][$tagstring]);

                // facciamo il merge di this->content che contiene i dati di tablesdata e node con row
                // che contiene i dati della riga (se siamo dentro un tag loop ci sono, parola)...
                // MA COME FACEVAMO PRIMA???
                //$passparam = array_merge($this->content, $row);
                //$ret = call_user_func($this->vtable['linear'][$tagstring], $this->connh, $row, $this->PRISCILLA_SESSION, $tagparam[$tagstring]);

                $cfparam = array(
                        $this->connh,
                        $row,
                        &$this->PRISCILLA_SESSION,
                        $tagparam[$tagstring]
                );

                $ret = call_user_func_array($this->vtable['linear'][$tagstring], $cfparam);


                if (is_array($ret)) {
                    foreach ($ret as $varname => $varvalue) {
                        if (is_object($varvalue)) $this->content[$varname] =& $varvalue;
                        else $this->content[$varname] = $varvalue;
                    }
                    $ret = '';
                }

                // limito la sostistuzione ad un elemento cos� si evita di mangiare due tag uguali
                $string = preg_replace("/".preg_quote($match[0], '/')."/", $ret, $string, 1);
            }
            else
            {
                if ($this->debug) 
                    $this->out_debug("linear function ".$this->vtable['linear'][$tagstring]." NOT FOUND");

                // se il tag e' un campo di content o node (si potrebbero aggiungere opzioni)
                if (array_key_exists($tagstring, $row)) {
                    $string = str_replace($match[0], $row[$tagstring], $string);
                    if ($this->debug) 
                        $this->out_debug("contest tag: ".$tagstring."=".htmlspecialchars($row[$tagstring]));
                }
                else {
                    $string = str_replace($match[0], '', $string); // e' qui che mangia i tag che non esistono ...
                    if ($this->debug) 
                        $this->out_debug("tag: ".$tagstring." not found");
                }
                // ed anche qui che ci sono problemi di js ... a volte si mangia anche loro ... ingordo di un parser!
            }

            // se si deve interrompere il ciclo per evitare annidati
            if ($breakWhile == true) break;
        }

        return stripslashes($string);
        //return $string;
    }

    function parse_dump($string, $risoluzione)
    {
        while (preg_match("/index\.phtml\?id=(\d+)\D*/", $string, $regs))
        {
            $filename = $risoluzione[$regs[1]];
            $string = preg_replace("/index\.phtml\?id=$regs[1]/", $filename, $string);
        }
        return $string;
    }

    // funzione statica, controlla se si hanno i permessi di usare determinati tag
    function check_string($string, $vtable_check)
    {
        $breakWhile = false;
        $match = array();

        while (($count++ < MAX_SUBST_LIMIT) && preg_match("/\{(\w*)(\s*\w*\s*=\s*\"?[^\{\}]+\"?\s*)*\}/i", $string, $match)) {
            $tagstring = $match[1];

            // per ogni tag trovato nel blocco
            $params = array();
            $options = array();
            $o = preg_match_all("/\s*(\w+)\s*=\s*\\\*\"(.*)\\\*\"\s*/iU", $match[2], $options);

            foreach ($options[1] as $key=>$val)
                $params[$val] = $options[2][$key];

            if (array_key_exists($tagstring, $vtable_check)) {
                $obj = new obj_class($params['id'], $vtable_check[$tagstring]);
                $check = $obj->checkperm();
                if (!$check)
                    $string = str_replace($match[0], '', $string);
           }
        }

        return $string;
    }

    // parsa le condizioni dell'if
    function parse_if_condition($cond_string)
    {
        //$cond_string = preg_replace("/(\w+)/", "'\$1'", $cond_string);

        ob_start();
        eval("\$res = (".$cond_string.") ? true : false;");
        $outbuffer = ob_get_contents();
        ob_end_clean();

        if ($this->debug)
            $this->out_debug("parse_if di ".$cond_string.", outbuffer: ".$outbuffer);
        
        if ($outbuffer != '')
            $res = false;

        return $res;
    }

    function out_debug($o)
    {
        switch ($this->debug_to)
        {
            case 'stdout':
                if (is_array($o) && count($o)) {
                    echo "<br /><pre>";
                    print_r($o);
                    echo "</pre>";
                }
                else
                    echo "<br />".$o;
            break;
            case 'file':
                if ($this->debug_fp) {
                    if (is_array($o) && count($o))
                        fwrite($this->debug_fp, "\n".print_r($o, false));
                    else
                        fwrite($this->debug_fp, "\n".strip_tags($o));
                }
            break;
        }
    }

    function debug_clean()
    {
        //echo "<br>!!!debug clean";
        if ($this->debug_to == 'file')
            fclose($this->debug_fp);
    }
}

class publisher extends parser
{
    var $outfile;
    var $filehandler;

    var $debug = 0;

    var $allto = '';

    function set_out_file($fn)
    {
        $this->outfile = $fn;
        if ($this->outfile)
        {
            $this->filehandler = fopen($this->outfile, "w") or die('non posso creare il file');
            if ($this->filehandler) echo "aperto il filehandler ".$this->outfile ;
        }
    }

    function publish($text, $risoluzione, $content='')
    {
        if ($this->debug) echo "<br>pubblisher->publish";

        if (trim($text) != '')
        {
            if (is_array($content))
            {
                $row =& $content;
            }
            else $row =& $this->content;
            $text = $this->parse_string($text, $row);
        }

        if ($this->filehandler)
        {
            $text = $this->parse_dump($text, $risoluzione);
            fwrite($this->filehandler, $text);
            echo ".";
            flush();
        }
        else
        {
            if ($this->debug) echo "<br>output: ";
            echo $text;
            flush();
            return $text;
        }
    }

    function get_allto()
    {
        $ret = $this->allto;
        $this->allto = '';
        return $ret;
    }

    function set_debug_fp()
    {
        $this->debug_fp = false;
    }

    function close()
    {
        if ($this->outfile)
        {
            fclose($this->filehandler);
            echo " chiuso<BR>\n";
        }
    }
}

/*function jsaddslashes($s)
{
    $o = '';
    $l = strlen($s);
    for($i = 0; $i < $l; $i++)
    {
        $c = $s[$i];
        switch($c)
        {
//            case '<': $o .= '\\x3c'; break;
//            case '>': $o .='\\x3e'; break;
            case '\'': $o .= '\\\''; break;
            case '\\': $o .= '\\\\'; break;
            case '"': $o .= '\\"'; break;
//            case "\n": $o .= '\\n'; break;
//            case "\r": $o .= '\\r'; break;
            default: $o .= $c;
        }
    }
    return $o;
}*/

?>
