<?

// $Id: feeds_loop.inc.php 5140 2012-04-11 15:02:10Z calicant $

require_once PRISCILLA_LOCAL_PATH . "modules/feeds/inc/config.inc.php";
require_once PRISCILLA_LOCAL_PATH . "modules/feeds/lib/feed_parser.php";


set_include_path(get_include_path() . PATH_SEPARATOR . "/var/www/vhost/" . "packages/zend/library/");
require_once "/var/www/vhost/" . "packages/zend/library/Zend/Feed/Reader.php";

/**
 ** tag: feed
 ** desc: ATTENZIONE, deprecato usare feedreader
 ** desc: lettura di feeds RSS
 ** opt: url path http al feed xml (richiesto)
 ** opt: enconding set di caratteri da usare, se non fornito cerca di auto-capirlo
 ** opt: n numero di item da mostrare, se non fornito n = 5
 ** eg: <%feed url="http://www.repubblica.it/rss/politica/rss2.0.xml" n="3" encoding="utf-8"%>
 ** eg: <a href="{link}">{title}</a><br />
 ** eg: <%end%>
 **/
function feeds (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco) {

    if (trim($options["url"]) != "") {

        $conf = array('url' => $options["url"]);

        if (trim($options['encoding']) != "")
            $conf['encoding'] = $options['encoding'];

        $feed_parser = new feed_parser($conf);

        if (is_numeric($options['n']))
            $n = $options['n'];
        else
            $n = 5;

        $i = 0;
        while ($feed = $feed_parser->next_item()) {
            if ($i >= $n)
                break;

            $publisher->publish($blocco, $risoluzione, $feed);
            $i++;
        }
    }
}


/**
 ** tag: feedreader
 ** desc: lettura di feeds RSS
 ** desc: attenzione: deve essere installata sul server la libreria Zend in /var/www/vhost/packages/zend/ (percorso fisso)
 ** opt: url path http al feed xml (richiesto)
 ** opt: n numero di item da mostrare, se non fornito n = 5
 ** opt: splitimage se posto a yes separa l'immagine dall contenuto e la fornisce in {image}
 ** eg: <%feedreader url="http://www.repubblica.it/rss/politica/rss2.0.xml" n="3"%>
 ** eg: <a href="{link}">{title}</a><br />
 ** eg: <%end%>
 **/
function feedreader (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco) {

    if (trim($options["url"]) == "")
        return "";
    else
	$url = $options["url"];

    if (is_numeric($options['n']))
        $n = $options['n'];
    else
        $n = 5;

    try {
    $feed = Zend_Feed_Reader::import($url);
    }
    catch (Exception $e) {
     echo 'Exception caught: ',  $e->getMessage(), "\n";
     return "";
    }    


    $data = array(
        'title'        => $feed->getTitle(),
        'link'         => $feed->getLink(),
        'dateModified' => $feed->getDateModified(),
        'description'  => $feed->getDescription(),
        'language'     => $feed->getLanguage(),
        'entries'      => array(),
    );
 
    $i = 0;
    foreach ($feed as $entry) {

        $a_l = explode("/", $entry->getLink());
        foreach ($a_l as $ls)
	    if (is_numeric($ls))
		$idn = $ls;

	$content = $entry->getContent();

	if ($options["splitimage"] == "yes") {
		$a_c = explode("<content:encoded>", $content);

		//print_r($a_c);
		$have_image = preg_match_all('/<img[^>]+>/i', $a_c[0], $res);
		if ($have_image) {
			$content = str_replace($res[0][0], "", $a_c[0]);

			$a_ti = explode('"', $res[0][0]);
			$image = "<img src=\"" . str_replace("medium", "large", $a_ti[3]) . "\" />\n";

		}
		else
			$image = "";
	}

	$l = $entry->getLink();
	$a_l = explode("/", $l);
	$seotitle = $a_l[count($a_l) - 1];

        $edata = array(
            'title'        => $entry->getTitle(),
            'description'  => $entry->getDescription(),
	    'dateModified' => $entry->getDateModified()->toString(),
            'authors'      => array_shift($entry->getAuthors()->getValues()),
            'link'         => $entry->getLink(),
            'content'      => $content,
            'idn'	   => $idn,
	    'picture'	   => $image,
	    'seotitle'     => $seotitle,
        );
	//$data['entries'][] = $edata;

        $publisher->publish($blocco, $risoluzione, $edata);

        $i++;
        if ($i >= $n)
            break;
    }
}

?>
