<?php

// $Id: mail_engine_class.php 5140 2012-04-11 15:02:10Z calicant $

class MailEngine {

    var $_headers = array();
    var $_message = '';
    var $_mail_boundary = '';
    var $_charset = "utf-8";
    var $_connh;

    function MailEngine ($connh, $from, $to, $subject, $message_data, $is_html_mail = false) {

        $this->_connh = $connh;

        $defined_charset = $this->getDefinedCharset();
        if ($defined_charset != "")
            $_charset = $defined_charset;

	if ($is_html_mail) {

	    $this->_mail_boundary = md5(uniqid(time()));

	    $this->_headers = array(
		"From: $from",
		"To: $to",
		"Subject: $subject",
		"Date: " . strftime("%a, %d %b %Y %H:%M:%S %Z"),
		"X-Mailer: " . NEWSLETTER_MAILER_NAME . NEWSLETTER_VERSION,
		"MIME-Version: 1.0",
		"Content-type: multipart/mixed;boundary=\"" . $this->_mail_boundary . "\""
	    );

	    $this->_message .= "--" . $this->_mail_boundary . "\r\n";
	    $this->_message .= "Content-type: text/html; charset=$_charset;\r\n";
	    $this->_message .= "Content-transfer-encoding: 8bit\r\n\r\n";
	    $this->_message .= $message_data;
	    $this->_message .= "\r\n--" . $this->_mail_boundary . "--\r\n";
	    
	} // if ($is_html_mail)
	else {
	    $this->_headers = array(
		"From: $from",
		"To: $to",
		"Subject: $subject",
		"Date: " . strftime("%a, %d %b %Y %H:%M:%S %Z"),
                "X-Mailer: " . NEWSLETTER_MAILER_NAME . NEWSLETTER_VERSION,
        "Content-Type: text/plain; charset=" . $_charset
	    );
	    $this->_message = $message_data;
	}

    } // MailEngine


    function getMailHeaders() {

    return $this->_headers;
    } // getMailHeaders


    function getMailMessage() {
    return $this->_message;
    } // getMailMessage


    function getDefinedCharset() {

        $dbquery = "SELECT `default_charset` FROM `priscilla` LIMIT 1";
        $rs = $this->_connh->Execute($dbquery);

        if ($rs && $rs->RecordCount() == 1 && trim($rs->fields('default_charset')) != "")
            return $rs->fields('default_charset'); 

    return "";
    }

} // class


?>
