<?

// http://lbak.co.uk/blog/15/08/2010/recursive-scandir-function-php/
function recursive_directory_tree ($directory = null) {

    if ($directory == null) {
        $directory = getcwd();
    }

    $return = array();
    if (is_dir($directory)) {
        foreach(scandir($directory) as $file) {

            if ($file == "." || $file == "..") {
                continue;
            }
            if (is_dir($directory."/".$file)) {
                $return[$file] = recursive_directory_tree($directory."/".$file);
            }
            else {
                $return[] = $file;
            }
        }
    }
    else {
        $return[] = $directory;
    }
    
return $return;
}

function make_ulli($array, $n, $id) {

    if ($n == 1)
        $s_class = " id=\"$id\" class=\"filetree\""; 
    else
        $s_class = "";

    $return = "<ul" . $s_class . ">\n";

    $n++; 

    if (is_array($array) && count($array) > 0) {
        foreach ($array as $k => $v) {
            if (is_array($v) && count($v) > 0) {
                $return .= "\t<li class=\"closed\">" . "<span class=\"folder\">" . $k . "</span>" . make_ulli($v, $n, $id) . "</li>\n";
            }
            else if (!is_array($v)) {
                $return .= "\t<li><span class=\"file\">" . $v . "</span></li>\n";
            }
        }
    } else {}
 
    $return .= "</ul>\n";
 
    return $return;
}

function readDirR($dir = "./", $stripbase, $downloader, $mode) {
    $listing = opendir($dir);
    $return = array ();
    while(($entry = readdir($listing)) !== false) {
        if ($entry != "." && $entry != "..") {
            $dir = preg_replace("/^(.*)(\/)+$/", "$1", $dir);
            $item = $dir . "/" . $entry;

            if (is_file($item)) {
                $targetf = str_replace($stripbase . "/", "", $dir . "/" . $entry);
                $p = md5($targetf . "__fallAt0__" . $mode . BAOBAB_USER);
                $link = '<a class=\"docDownload\" title=\"scarica allegato ' . $entry . '\" href="' . $downloader . '&f=' . base64_encode($targetf) . "&p=$p&u=$mode" . '">' . $entry . '</a>';
            }
            else
                $link = $entry;


            if (is_file($item)) {
                $return[] = $link;
            }
            elseif (is_dir($item)) {
                $return[$link] = readDirR($item, $stripbase, $downloader, $mode);
            } else {}
        } else {}
    }
 
    return $return;
}


/**
 ** tag: webservices_dibilla
 ** desc: estrae un record in maniera casuale dalla tabella datatonic_dibilla specificata
 ** opt: id_datatonic_conf id della configurazione datatatonic_conf
 ** opt: table nome della tabella da cui andare a prendere la riga
 ** opt: fields nomi dei campi da estrarre. Se più di uno separare con ;
 ** opt: where clausola where opzionale per l'estrazione dei record
 ** opt: format formato di stampa dei campi estratti. ogni %s corrisponde ad un campo specificato nel parametro fields seguendo lo stesso ordine. il numero delle stringhe di formattazione deve essere uguale al numero di campi richiesti. In caso contrario viene ritornata la formattazione standard che divide ogni campo con uno spazio bianco. Per maggiori informazioni sui caratteri di formattazione consultare la pagina http://www.php.net/manual/en/function.sprintf.php
 ** eg: {webservices_dibilla id_datatonic_conf="1" table="dibilla_dinosauri" fields="nome;nome_scientifico;descrizione" format="%s, [%s] - %s"}
 ** eg: in questo esempio verrà estratta dalla tabella dinosauri la frase: nome, [nome_scientifico] - descrizione
 **/
function webservices_dibilla ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['id_datatonic_conf']) || !trim($options['table']) || !trim($options['fields']))
        return '';

    $rs = $connh->Execute("SELECT * FROM datatonic_conf WHERE id='".$options['id_datatonic_conf']."'");
    if (!$rs->RecordCount())
        return '';
    $datatonic_conf = $rs->fields;

    require_once "adm/lib/nusoap.php";

    $serverpath = $datatonic_conf['serverpath'];

    $client = new soapclient0($serverpath);
    if ($fault = $client->getError())
        $ret = "<span>ERROR DT CLIENT: <strong>".$fault."</strong></span>";

    $param = array();
    $param['datatonic_username'] = $datatonic_conf['username'];
    $param['datatonic_password'] = $datatonic_conf['password'];

    $param['table'] = $options['table'];
    $fields = explode(';', $options['fields']);
    $param['fields'] = serialize($fields);
    $param['where'] = $options['where'];

    $ret = $client->call("random_row", $param);
    if ($fault = $client->getError())
        $ret = "<span>ERROR CALLING DT FUNCTION: <strong>".$fault."</strong></span>";
    else {
        $ret = unserialize($ret);
        $strret = '';
        if ($options['format'] && substr_count($options['format'], '%s') == count($ret))
            $strret = vsprintf($options['format'], $ret);
        else {
            foreach ($ret as $f => $v)
                $strret .= $v.' ';
        }
    }

    unset($client);

    return $strret;
}

/**
 ** tag: quick_doc_baobab
 ** desc: mostra i documenti di datatonic baobab (per community)
 ** opt: nessuna
 ** eg: {quick_doc_baobab}
 **/
function quick_doc_baobab ($connh, $row, &$PRISCILLA_SESSION, $options) {

	// se un utente e' entrato in area riservata
	// mostra i documenti di quel nome utente

    require_once "baobab_conf.inc.php";
    $downloader = BAOBAB_HTTP_DOCS;


    $is_community_user = false;
    if ($PRISCILLA_SESSION->exists('community_user')) {
        $cu = $PRISCILLA_SESSION->getvalue('community_user');
        if (trim($cu->username) != '' && trim($cu->password) != '')
            $is_community_user = true;
    }

    if (!$is_community_user)
    	return "<p class=\"accessdenied\">Occorre fare il login per accedere all'area riservata</p>";
    else {

	$sdocr = "";

    //$cu->username = "pepe"; // TODO: remove

	if (file_exists(VFS_UPLOAD_DIR . $cu->username)) {
	    $moduledir = VFS_UPLOAD_DIR . $cu->username;
        $mode = $cu->username;
        $a = readDirR($moduledir, $moduledir, $downloader, $mode);
        $n = 1;
        $sdocr .= make_ulli($a, $n, "lista-personali");
        $sdocr .= "<script>$(\"#lista-personali\").treeview();</script>";
	} // if

	$sdoca = "";

	if (file_exists(VFS_UPLOAD_DIR . BAOBAB_ALL)) {
	    $moduledir = VFS_UPLOAD_DIR . BAOBAB_ALL;
        $mode = "tutti";
        $a = readDirR($moduledir, $moduledir, $downloader, $mode);
        $n = 1;
        $sdoca .= make_ulli($a, $n, "lista-tutti");
        $sdoca .= "<script>$(\"#lista-tutti\").treeview();</script>";
	} // if

	$alldoc = "";

	if ($sdocr != "")
		$alldoc .= "<p class=\"docUser\">Documenti riservati</p>\n" . $sdocr . "\n";


	if ($sdoca != "")
		$alldoc .= "<p class=\"docAll\">Documenti comuni</p>\n" . $sdoca . "\n";

	if ($alldoc == "")
		$alldoc = "<p class=\"docNo\">Non ci sono documenti</p>\n";

	return $alldoc;
    } // else	
}


/**
 ** tag: quick_listaclienti_baobab
 ** desc: mostra l'elenco dei clienti baobab
 ** opt: nessuna
 ** eg: {quick_listaclienti_baobab}
 **/
function quick_listaclienti_baobab ($connh, $row, &$PRISCILLA_SESSION, $options) {

    require_once "baobab_conf.inc.php";
    // connessione a datatonic baobab

    $connt = &ADONewConnection("mysqlt");
    $res = $connt->NConnect(
        BAOBAB_DBHOST,
        BAOBAB_DBUSER,
        BAOBAB_DBPASS,
        BAOBAB_DBNAME
    );

    $ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
    $ADODB_COUNTRECS = false;

    if (!$res)
        die("Fatal Error: could not connect to Datatonic Baobab");

   
    $dbquery = "SELECT * FROM `swisscut_anagrafica` WHERE (`not_public` != 1 || `not_public` IS NULL) AND `tipologia` = 'cliente' ORDER BY `societa` ASC";
    $rs = select($dbquery, $connt);
    if ($rs && $rs->RecordCount()) {
        $s = "<ul class=\"lista-clienti-baobab\">\n";
        while (!$rs->EOF) {
            $row = $rs->fields;
            $url = $row["url"];
            if (trim($row["societa"]) != "") {

                $societa = stripslashes($row["societa"]);

                if (trim($url) != "") {
                        if (substr(strtolower($url), 7) !=  "http://")
                            $url = "http://" . $url;
                        $s .= "<li><a title=\"$url\" target=\"_blank\" href=\"$url\">" . $societa . "</a></li>\n";
                }
                else
                        $s .= "<li>" . $societa . "</li>\n";
            }

            $rs->MoveNext();
        }

        $s .= "</ul>\n";
    }
 
return $s;
}


?>
